<?php
//
//
//-------------------------------------------------------
//-- HANGMAN v2.0                                      --
//-- PHP game by Giovanni Crisci                       --
//-- http://giovi.supereva.it                          --
//-- Images taken from ASP code written by             --
//-- ASP101 http://www.asp101.com                      --
//-- Requires PEAR installed                           --
//-- http://pear.php.net                               --
//-------------------------------------------------------
//
// administration tool
//

require_once ('config.php');
require_once ('DB.php');

// sessions are used to store login username and password

session_start();

// shows the first part of the template

$pagina = file($template);
$totrighe = count($pagina);
$i = 0;
while (rtrim($pagina[$i])!="<!--HANGMAN-->") {
 print $pagina[$i];
 $i++;
}

// checks if the user is already logged in

if (isset($_SESSION['admuser'])) {
 $admuser = $_SESSION['admuser'];
 $admpwd = $_SESSION['admpwd'];
}

// sets user and password if posted

if (isset($_POST['admuser']) and isset($_POST['admpwd'])) {
 $admuser = $_POST['admuser'];
 $admpwd = md5($_POST['admpwd']);
}

// checks that user and password are correct

if (isset($admuser)) {
 $dsn = "mysql://$user:$pword@$dhost/$dbase";
 $db = DB::connect($dsn, true);
 if (DB::isError($db))
  die ($db->getMessage());
 $res = $db->query('select word, best from '.$dtable.' where id = 1');
 if (DB::isError($res))
  die ($res->getMessage());
 $riga = $res->fetchRow();
 if ($riga[1]==$admuser and $riga[0]==$admpwd) $grantacc = true;
  else $grantacc = false;
 $_SESSION['admuser'] = $admuser;
 $_SESSION['admpwd'] = $admpwd;
}

// if access is granted selects the option from the menu

if (isset($grantacc)) {
 if ($grantacc) {
  if (isset($_GET['admenu'])) {
   print ('<h3>'.$menuarr[$_GET['admenu']].'</h3>');
   echo ("\n");
   switch ($_GET['admenu']) {

// option 1 - add a word to the database

    case 1:
     if (isset($_POST['addword0'])) {
	  $addwordarray = array ();
	  $addcheck = false;
	  for ($l=0; $l<=9; $l++) {array_push($addwordarray, $_POST['addword'.$l]);}
	  foreach ($addwordarray as $addword) {

// the word must contain only allowed letters

       $addword = strtoupper ($addword);
       $addword = ereg_replace ("[^A-Z\-\ ]*", '', $addword);

// avoids to insert an empty word

       if ($addword=='') continue;
       else {

// avoids that a word already present is inserted again

        $res = $db->query('select id from '.$dtable.' where word = \''.$addword.'\'');
        $riga = $res->fetchRow();
        if ($riga!='') {
         print ('<p>'.$addword.' '.ALRINSRT.'</p>');
         echo ("\n");
        }
        else {

// inserts the word

         $res = $db->query('insert into '.$dtable.' (word) values (\''.utf8_encode($addword).'\')');
         if (DB::isError($res))
          die ($res->getMessage());
         print ('<p>'.$addword.' '.INSRTW.'</p>');
		 $addcheck = true;
         echo ("\n");
        } 
       }
      }	
      if (!$addcheck) echo ("<p>".NOTINSRT."</p>\n");
      print ('<p><a href="'.$_SERVER['PHP_SELF'].'?admenu=1">'.OTHERWRD.'</a></p>');
      echo ("\n");
     }
     else {

// show to form to insert the word

      ?>
      <form method="post" action="<?=$_SERVER['PHP_SELF']; ?>?admenu=1">
       <?=INSWORD; ?><br />
	   <?php
	   for ($l=0; $l<=9; $l++) {
	    echo ("<input type=\"text\" name=\"addword$l\" size=\"25\" maxlength=\"25\" /><br />\n");
	   }
	   ?>
       <input type="submit" value="<?=SBMT; ?>" name="go" />
      </form>
      <?php
     }
    break;

// option 2 - add a file of words into the database

    case 2:
     if (isset($_FILES['wordfile'])) {
      if (is_uploaded_file($_FILES['wordfile']['tmp_name'])) {
       $wordfile = file($_FILES['wordfile']['tmp_name']);
       foreach ($wordfile as $addword) {

// the word must contain only allowed letters

        $addword = strtoupper (rtrim ($addword));
        $addword = ereg_replace ("[^A-Z\-\ ]*", '', $addword);
        if ($addword=='') {

// avoids to insert an empty word

         print ('<p>'.NOTINSRT.'</p>');
         echo ("\n");
        }
        else {

// avoids that a word already present is inserted again

         $res = $db->query('select id from '.$dtable.' where word = \''.$addword.'\'');
         $riga = $res->fetchRow();
         if ($riga!='') {
          print ('<p>'.$addword.' '.ALRINSRT.'</p>');
          echo ("\n");
         }
         else {

// inserts the word

          $res = $db->query('insert into '.$dtable.' (word) values (\''.utf8_encode($addword).'\')');
          if (DB::isError($res))
           die ($res->getMessage());
          print ('<p>'.$addword.' '.INSRTW.'</p>');
          echo ("\n");
         } 
        }
       }
      }
     }
     else {

// show to form to insert the file with words

      ?>
      <form enctype="multipart/form-data" method="post" action="<?=$_SERVER['PHP_SELF']; ?>?admenu=2">
       <p><?=INSFILE; ?></p>
       <input type="file" name="wordfile" size="25" /><br />
       <input type="submit" value="<?=SBMT; ?>" name="go" />
      </form>
      <?php
     }
    break;

// option 3 - modify a word or a score

    case 3:
     if (isset($_POST['go'])) {

// modifications are posted and inserted

      for ($k=1; $k<=$_POST['fnumres']; $k++) {
       $chgword = strtoupper ($_POST['fword'.$k]);
       $chgword = ereg_replace ("[^A-Z\-\ ]*", '', $chgword);

// chances must not be more than 6

       $ftent = min ($_POST['ftent'.$k], 6);
       $res = $db->query('update '.$dtable.
        ' set word = \''.utf8_encode($chgword).'\', best = \''.$_POST['fbest'.$k].
        '\', errors = \''.$ftent.'\', time = \''.$_POST['ftime'.$k].
        '\' where id = '.$_POST['fid'.$k]);
      }
      echo ("<p>".DATAUP."</p>\n");
     }

// shows the words and lets edit them

     $res = $db->query('select * from '.$dtable.' where id > 1 order by word');
     if (isset($_GET['from'])) $from = $_GET['from'];
      else $from = 0;
     echo ("<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."?admenu=3&amp;from=".$from."\">\n");
     echo (" <table width=\"100%\">\n  <tr>\n   <td>".WRD."</td>\n   <td>".
      BST."</td>\n   <td>".TNT."</td>\n   <td>".TME."</td>\n  </tr>\n");

// chooses the range from which the words are taken for editing

     $res_per_page = 10;
     $to = $from + $res_per_page - 1;
     $numres = 0;
     foreach (range($from, $to) as $rownum) {
      if (!$riga = $res->fetchRow(DB_FETCHMODE_ORDERED, $rownum)) break;
      $numres++;
      echo ("  <tr>\n   <td><input type=\"hidden\" name=\"fid".$numres."\" value=\"".
       $riga[0]."\" /><input type=\"text\" name=\"fword".$numres."\" value=\"".
       $riga[1]."\" size=\"25\" maxlength=\"25\" /></td>\n   <td><input type=\"text\" name=\"fbest".
       $numres."\" value=\"".$riga[2]."\" size=\"15\" maxlength=\"15\" /></td>\n   <td><input type=\"text\" name=\"ftent".
       $numres."\" value=\"".$riga[3]."\" size=\"2\" maxlength=\"1\" /></td>\n   <td><input type=\"text\" name=\"ftime".
       $numres."\" value=\"".$riga[4]."\" size=\"4\" maxlength=\"3\" /></td>\n   <td>\n  </tr>\n");
     }
     echo (" </table>\n");
     echo (" <input type=\"hidden\" name=\"fnumres\" value=\"".$numres."\" />\n");
     echo (" <input type=\"submit\" value=\"".SBMT."\" name=\"go\" />\n");
     echo ("</form>\n");
     $numrighe = $res->numRows($res);

// navigation bar

     if ($numrighe>$res_per_page) {
      echo ("<p>\n");
      if ($from>0) {
       print (' <a href="'.$_SERVER['PHP_SELF'].'?admenu=3&amp;from='.max($from - $res_per_page, 0).'">'.LPRV.'</a>');
       echo ("\n");
      }
      if ($to<$numrighe) {
       print (' <a href="'.$_SERVER['PHP_SELF'].'?admenu=3&amp;from='.($from + $res_per_page).'">'.LNXT.'</a>');
       echo ("\n");
      }
      echo ("</p>\n");
     }
     echo ("\n");
     
    break;

// option 4 - delete a word or a score

    case 4:
     if (isset($_GET['from'])) $from = $_GET['from'];
      else $from = 0;
     if (isset($_POST['go'])) {

// checks if words/scores to be deleted were chosen

      if ($_POST['go']==SBMT) {
       echo ("<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."?admenu=4&amp;from=".$from."\">\n");
       $controllo = false;
       for ($k=1; $k<=$_POST['fnumres']; $k++) {
        if ($_POST['fdel'.$k]!='off') $controllo=true;
       }
       if ($controllo) {

// asks confirmation for deletion

        $erword = "";
        $erscore = "";
        echo (" <input type=\"hidden\" name=\"fnumres\" value=\"".$_POST['fnumres']."\" />\n");
        for ($k=1; $k<=$_POST['fnumres']; $k++) {
         if ($_POST['fdel'.$k]=='all') {
          echo (" <input type=\"hidden\" name=\"fdel".$k."\" value=\"all\" />\n");
          echo (" <input type=\"hidden\" name=\"fid".$k."\" value=\"".$_POST['fid'.$k]."\" />\n");
          $erword.= ("  ".$_POST['fword'.$k]."<br />\n");
         }
         if ($_POST['fdel'.$k]=='score') {
          echo (" <input type=\"hidden\" name=\"fdel".$k."\" value=\"score\" />\n");
          echo (" <input type=\"hidden\" name=\"fid".$k."\" value=\"".$_POST['fid'.$k]."\" />\n");
          $erscore.= ("  ".$_POST['fword'.$k]."<br />\n");
         }
        }
       echo (" <p>\n  ".CNFRWORD."<br />\n".$erword);
       if ($erword=="") echo (" -----<br />\n");
       echo ("  ".CNFRSCORE."<br />\n".$erscore);
       if ($erscore=="") echo (" -----<br />\n");
       echo (" </p>\n");
       echo (" <input type=\"submit\" value=\"".CNFRYES."\" name=\"go\" />\n");
       }
       else echo ("<p>".NTHGDO."</p>\n"); 
       echo (" <input type=\"submit\" value=\"".BTTBACK."\" name=\"back\" />\n");
       echo ("</form>\n");
      }
      if ($_POST['go']==CNFRYES) {

// deletion confirmed - words/scores are deleted

       $contrtable = false;
       for ($k=1; $k<=$_POST['fnumres']; $k++) {
        if (isset($_POST['fdel'.$k])) {
         if ($_POST['fdel'.$k]=="all") {
          $res = $db->query('delete from '.$dtable.
           ' where id = '.$_POST['fid'.$k].' limit 1');
          $contrtable = true;
         }
         if ($_POST['fdel'.$k]=="score") {
          $res = $db->query('update '.$dtable.
           ' set best = \'\', errors = 6, time = \'\' where id = '.
           $_POST['fid'.$k]);
         }
        }
       }

// repair id column after deletion

       if ($contrtable) {
        $res = $db->query('alter table '.$dtable.' drop id');
        $res = $db->query('alter table '.$dtable.' add id '.
         'int unsigned not null auto_increment primary key first'); 
       }
       echo ("<p>".DATAUP."</p>\n");
      }
     }

// shows words and lets choose what to do

     if (!isset($controllo)) {
      $res = $db->query('select * from '.$dtable.' where id > 1 order by word');
      echo ("<form method=\"post\" action=\"".$_SERVER['PHP_SELF']."?admenu=4&amp;from=".$from."\">\n");
      echo (" <table width=\"100%\">\n  <tr>\n   <td>".WRD."</td>\n   <td>".
       BST."</td>\n   <td>".TNT."</td>\n   <td>".TME."</td>\n   <td>".
       DLTWRD."</td>\n   <td>".DLTSCR."</td>\n   <td>".DONTHG."</td>\n  </tr>\n");

// chooses the range from which the words are taken for editing

      $res_per_page = 10;
      $to = $from + $res_per_page - 1;
      $numres = 0;
      foreach (range($from, $to) as $rownum) {
       if (!$riga = $res->fetchRow(DB_FETCHMODE_ORDERED, $rownum)) break;
       $numres++;
       echo ("  <tr>\n   <td><input type=\"hidden\" name=\"fid".$numres."\" value=\"".
        $riga[0]."\" /><input type=\"hidden\" name=\"fword".$numres."\" value=\"".$riga[1].
        "\" />".$riga[1]."</td>\n   <td>".$riga[2]."</td>\n   <td>".
        $riga[3]."</td>\n   <td>".$riga[4]."</td>\n   <td>".
        "<input type=\"radio\" name=\"fdel".$numres."\" value=\"all\" /></td>\n".
        "   <td><input type=\"radio\" name=\"fdel".$numres."\" value=\"score\" />".
        "</td>\n   <td><input type=\"radio\" name=\"fdel".$numres."\" value=\"off".
        "\" checked /></td>\n  </tr>\n");
      }
      echo (" </table>\n");
      echo (" <input type=\"hidden\" name=\"fnumres\" value=\"".$numres."\" />\n");
      echo (" <input type=\"submit\" value=\"".SBMT."\" name=\"go\" />\n");
      echo ("</form>\n");
      $numrighe = $res->numRows($res);

// navigation bar

      if ($numrighe>$res_per_page) {
       echo ("<p>\n");
       if ($from>0) {
        print (' <a href="'.$_SERVER['PHP_SELF'].'?admenu=4&amp;from='.max($from - $res_per_page, 0).'">'.LPRV.'</a>');
        echo ("\n");
       }
       if ($to<$numrighe) {
        print (' <a href="'.$_SERVER['PHP_SELF'].'?admenu=4&amp;from='.($from + $res_per_page).'">'.LNXT.'</a>');
        echo ("\n");
       }
       echo ("</p>\n");
      }
      echo ("\n");
     }
     break;

// option 5 - change admin name

    case 5:
     if (isset($_POST['go'])) {

// checks if password is right and then changes the admin name if not empty

      $res = $db->query('select word, best from '.$dtable.' where id = 1');
      $riga = $res->fetchRow();
      if (md5($_POST['admpwd'])==$riga[0] and $_POST['newadm']!='') {
       $res = $db->query('update '.$dtable.' set best = \''.$_POST['newadm'].'\' where id = 1');
       echo ("<p>".DATAUP."</p>\n");
      }
      else echo("<p>".NOTVALID."</p>\n");
     }
     else {

// shows the form to edit the admin name

      $res = $db->query('select best from '.$dtable.' where id = 1');
      $riga = $res->fetchRow();
      ?>
<form method="post" action="<?=$_SERVER['PHP_SELF']; ?>?admenu=5">
 <table width="300">
  <tr>
   <td><?=OLDADM; ?>:</td>
   <td><?=$riga[0]; ?></td>
  </tr>
  <tr>
   <td><?=NEWADM; ?>:</td>
   <td><input type="text" name="newadm" size="15" maxlength="15" /></td>
  </tr>
  <tr>
   <td><?=ADMPW; ?>:</td>
   <td><input type="password" name="admpwd" size="15" maxlength="15" /></td>
  </tr>
  <tr>
   <td>&nbsp;</td>
   <td><input type="submit" value="<?=SBMT; ?>" name="go" /></td>
  </tr>
 </table>
</form>
      <?php
     }
    break;

// option 6 - change admin password

    case 6:
     if (isset($_POST['go'])) {

// checks if the old password is right and that the new passwords match themselves
// then changes the admin password

      $res = $db->query('select word, best from '.$dtable.' where id = 1');
      $riga = $res->fetchRow();
      if (md5($_POST['admpwd'])==$riga[0] and $_POST['newpwd']!='' and$_POST['newpwd']==$_POST['newpwd2']) {
       $res = $db->query('update '.$dtable.' set word = \''.md5($_POST['newpwd']).'\' where id = 1');
       echo ("<p>".DATAUP."</p>\n");
      }
      else echo("<p>".NOTVALID."</p>\n");
     }
     else {

// shows the form to edit the admin password

      ?>
<form method="post" action="<?=$_SERVER['PHP_SELF']; ?>?admenu=6">
 <table width="300">
  <tr>
   <td><?=ADMPW; ?>:</td>
   <td><input type="password" name="admpwd" size="15" maxlength="15" /></td>
  </tr>
  <tr>
   <td><?=NEWPWD; ?>:</td>
   <td><input type="password" name="newpwd" size="15" maxlength="15" /></td>
  </tr>
  <tr>
   <td><?=ADMPW2; ?>:</td>
   <td><input type="password" name="newpwd2" size="15" maxlength="15" /></td>
  </tr>
  <tr>
   <td>&nbsp;</td>
   <td><input type="submit" value="<?=SBMT; ?>" name="go" /></td>
  </tr>
 </table>
</form>
      <?php
     }
    break;

// option 7 - log out - it just deletes the session variables

    case 7:
     $_SESSION['admuser'] = '';
     $_SESSION['admpwd'] = '';
     echo ("<p>".LOGGOUT."</p>\n");
    break;

   }

// shows the link to the main menu

   print ('<p><a href="'.$_SERVER['PHP_SELF'].'">'.MENPRINC.'</a></p>');
   echo ("\n");
  }
  else {

// shows the main menu

   $totmenu = count ($menuarr);
   $j=1;
   echo ("<p>\n");
   for ($j; $j<$totmenu; $j++) {
    print (' <a href="'.$_SERVER['PHP_SELF'].'?admenu='.$j.'">'.$menuarr[$j].'</a>');
    echo ("<br />\n");
   }
   echo ("</p>\n");
  }
 }
 else {
  echo("<p>".NOTVALID."</p>\n");
  unset ($grantacc);
 } 
 $db->disconnect();
}

// if username and password are not set, shows the form to insert them

if (!isset($grantacc)) {
 ?>
<form method="post" action="<?=$_SERVER['PHP_SELF']; ?>">
 <table width="300">
  <tr>
   <td><?=ADMUSR; ?>:</td>
   <td><input type="text" name="admuser" size="15" maxlength="15" /></td>
  </tr>
  <tr>
   <td><?=ADMPW; ?>:</td>
   <td><input type="password" name="admpwd" size="15" maxlength="15" /></td>
  </tr>
  <tr>
   <td>&nbsp;</td>
   <td><input type="submit" value="<?=SBMT; ?>" name="go" /></td>
  </tr>
 </table>
</form>
 <?php
}

// shows the final part of the template

print ('<p><a href="index.php">'.NWGAME.'</a></p>');
$i++;
while ($i<$totrighe) {
 print $pagina[$i];
 $i++;
}

?>